/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.5.8
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *---------------------- ժҪ ---------------------------------
;  *                      SCL-P11 ; SDA-P12
******************************************************************************/

#include "IIC.h"
uint16_t byte_count; 
uint8_t  number;
volatile uint8_t temp;

/************************************************
;  *    @          : Delay
;  *    @˵            :ͨʱ
;  *    @        :
;  *    @ز        :
;  ***********************************************/
void Delay(uint16_t Num)
{
    for(;Num>0;Num--)
    {
        NOP1();
    }
}

/************************************************
;  *    @     : IIC_Init
;  *    @˵       : IICʼ
;  *    @    :
;  *    @ز    :
;  ***********************************************/
void IIC_Init(void)
{
    IICCR0 = 0x81;           //master mode 100Kbps,SCL-P11 ; SDA-P12
//    SET_IICIE();
    SET_EA();
}

/************************************************
;  *    @     : IIC_Start
;  *    @˵       : IICʼź
;  *    @    : ӻַ 
;  *    @ز    :
;  ***********************************************/
void IIC_Start(uint8_t R_Slave_addr)
{
    IICAR = R_Slave_addr;
    SET_MTSAA();           //ʼź+ַ+
    while(!(IICCR1 & 0x80));
    IICCR1 &= ~0x80;
    while(!(IICCR1 & 0x80));
    IICCR1 &= ~0x80;
}

/************************************************
;  *    @     : IIC_Stop
;  *    @˵       : IICֹͣź
;  *    @    : 
;  *    @ز    :
;  ***********************************************/
void IIC_Stop()
{
    SET_MTSTP();
    while(!(IICCR1 & 0x80));
    IICCR1 &= ~0x80;
    while(!(IICCR1 & 0x80));
    IICCR1 &= ~0x80;
}

/************************************************
;  *    @            : simIIC_EEPROM_Test
;  *    @˵              : д
;  *    @          : 
;  *    @ز          : ض
;  ***********************************************/
uint8_t simIIC_EEPROM_Test(void) 
{
    uint8_t test_result = 1;  
    uint8_t WriteBuffer[Slave_BUFF_LEN]={0x56,0x25,0x22,0x89,0x78,0xE4,0x59,0xEE};
    volatile uint8_t ReadBuffer[Slave_BUFF_LEN]={0};
    uint8_t addr = 2;

    //ӡд
    printf("\r\n--Inf: Write Data: ");
    for(byte_count =0; byte_count < Slave_BUFF_LEN; byte_count++) 
    {
        printf(" 0x%bX",WriteBuffer[byte_count]);
    }

    IIC_Start(Slave_DEVICE_ADD);               //slave address , master write
    for(byte_count =0; byte_count < Slave_BUFF_LEN; byte_count++) {
        IIC_Send_Byte(WriteBuffer[byte_count]);
        Delay(5000);
    } 
    IIC_Stop();

    printf("\r\n--Inf: Master Write Finish.");
    Delay(1000);

    // Read from 24C02
    IIC_Start(Slave_DEVICE_ADD+1);             //slave address , master read
    while((IICSR & 0x01 ));                      //receive ack
    byte_count = 0;
    for(byte_count =0; byte_count < Slave_BUFF_LEN;byte_count++)
    {
        ReadBuffer[byte_count] = IIC_Read_Byte();
        Delay(5000); 
    }
    IIC_Stop(); 

    printf("\r\n--Inf: Read Data: ");
    for(byte_count =0; byte_count < Slave_BUFF_LEN;byte_count++) 
    {   
        if( ReadBuffer[byte_count] != WriteBuffer[byte_count]) 
        {
            test_result = 0;
        }
        printf(" 0x%bX",ReadBuffer[byte_count]); 
    }
    printf("\r\n--Inf: 24C02  Read Finish.");

    if(test_result == 0)
        printf("\r\n**Error: 24C02 communication ERROR! \r\n");
    else
        printf("\r\n--Inf: 24C02 communication success. \r\n");
    
    return test_result;
}

/************************************************
;  *    @            : IIC_Send_Byte
;  *    @˵              : дһ
;  *    @          : 
;  *    @ز          :
;  ***********************************************/
void IIC_Send_Byte(uint8_t data_test)
{
    if(!(IICSR & 0x01 ))
    {
        IICDR = data_test;
        SET_MTDTA();
        while(!(IICCR1 & 0x80));
        IICCR1 &= ~0x80;
    }
}

/************************************************
;  *    @            : IIC_Read_Byte
;  *    @˵              : һ  д
;  *    @          :
;  *    @ز          : 
;  ***********************************************/
uint8_t IIC_Read_Byte(void)
{ 
    if(number<7)
    {
        CLR_TACKS();
        number++;
    }
    else
    {
        SET_TACKS();
        number = 0;
    }
    SET_MRDTA();
    while(!(IICCR1 & 0x80));
    IICCR1 &= ~0x80;
    temp = IICDR;
    return temp;
}

void IIC_ISR(void) interrupt IIC_IRQn
{
    if(IICCR1 & 0x80 )
    {
        P00D = !P00D;
        IICCR1 &= ~DEF_SET_BIT7;
    }
}