#ifndef MC51F7084_COMMON_H__
#define MC51F7084_COMMON_H__

#include "MC51F7084.h"
#include <intrins.h> 

typedef enum {RESET = 0, SET = !RESET} flagstatus, ITstatus;

/*********** /дȨ **********/
#define __I   volatile const
#define __O   volatile
#define __IO   volatile
/* з */
typedef   signed  char       int8_t;
typedef   signed  int        int16_t;
typedef   signed  long       int32_t;
/* ޷ */
typedef unsigned  char       uint8_t;
typedef unsigned  int        uint16_t;
typedef unsigned  long       uint32_t;
typedef unsigned  char       u8;
typedef unsigned  int        u16;
typedef unsigned  long       u32;
typedef unsigned  char       uchar;
typedef unsigned  int        uint;

#define DEF_SET_BIT0         0x01
#define DEF_SET_BIT1         0x02
#define DEF_SET_BIT2         0x04
#define DEF_SET_BIT3         0x08
#define DEF_SET_BIT4         0x10
#define DEF_SET_BIT5         0x20
#define DEF_SET_BIT6         0x40
#define DEF_SET_BIT7         0x80

#define DEF_CLR_BIT0         0xFE
#define DEF_CLR_BIT1         0xFD
#define DEF_CLR_BIT2         0xFB
#define DEF_CLR_BIT3         0xF7
#define DEF_CLR_BIT4         0xEF
#define DEF_CLR_BIT5         0xDF
#define DEF_CLR_BIT6         0xBF
#define DEF_CLR_BIT7         0x7F

#define ENABLE               1
#define DISABLE              0

#define FAIL                 1
#define PASS                 0

#define HIGH                 1
#define LOW                  0

#define ON                   1
#define OFF                  0

#define TRUE                 1
#define FALSE                0


#define NOP1()  _nop_()
#define NOP2()  NOP1(),NOP1()
#define NOP3()  NOP2(),NOP1()
#define NOP4()  NOP3(),NOP1()
#define NOP5()  NOP4(),NOP1()
#define NOP6()  NOP5(),NOP1()
#define NOP7()  NOP6(),NOP1()
#define NOP8()  NOP7(),NOP1()
#define NOP9()  NOP8(),NOP1()
#define NOP10() NOP9(),NOP1()
#define NOP(N)  NOP##N()

#define  DISABLE_GIE()     EA = 0      //رж
#define  ENABLE_GIE()      EA = 1      //ʹж

/*  P0, 0x80H, SFR0  */

/*  SP, 0x81H, SFR0  */

/*  DPL, 0x82H, SFR0  */

/*  DPH, 0x83H, SFR0  */

/*  T3CNTL, 0x84H, SFR0  */

/*  T3CNTH, 0x85H, SFR0  */

/*  SLPCR, 0x86H, SFR0  */

/*  PCON, 0x87H, SFR0  */
// PCON^7;
// PCON^6;
// PCON^5;
#define SET_UART0EN()         PCON|=DEF_SET_BIT4      // PCON^4;
#define CLR_UART0EN()         PCON&=~DEF_SET_BIT4
#define SET_SMOD0()           PCON|=DEF_SET_BIT3      // PCON^3;
#define CLR_SMOD0()           PCON&=~DEF_SET_BIT3
#define SET_SSTAT0()          PCON|=DEF_SET_BIT2      // PCON^2;
#define CLR_SSTAT0()          PCON&=~DEF_SET_BIT2
#define SET_SLEEP()           PCON|=DEF_SET_BIT1      // PCON^1;
#define SET_STOP()            PCON|=DEF_SET_BIT0      // PCON^0;

/*  TCON, 0x88H, SFR0  */

/*  TMOD, 0x89H, SFR0  */
#define SET_GATE1()           TMOD|=DEF_SET_BIT7      // TMOD^7;
#define CLR_GATE1()           TMOD&=~DEF_SET_BIT7
#define SET_CT1()             TMOD|=DEF_SET_BIT6      // TMOD^6; 
#define CLR_CT1()             TMOD&=~DEF_SET_BIT6 
#define SET_T1M1()            TMOD|=DEF_SET_BIT5      // TMOD^5; 
#define CLR_T1M1()            TMOD&=~DEF_SET_BIT5
#define SET_T1M0()            TMOD|=DEF_SET_BIT4      // TMOD^4; 
#define CLR_T1M0()            TMOD&=~DEF_SET_BIT4
#define SET_GATE0()           TMOD|=DEF_SET_BIT3      // TMOD^3; 
#define CLR_GATE0()           TMOD&=~DEF_SET_BIT3
#define SET_CT0()             TMOD|=DEF_SET_BIT2      // TMOD^2;
#define CLR_CT0()             TMOD&=~DEF_SET_BIT2
#define SET_T0M1()            TMOD|=DEF_SET_BIT1      // TMOD^1;
#define CLR_T0M1()            TMOD&=~DEF_SET_BIT1
#define SET_T0M0()            TMOD|=DEF_SET_BIT0      // TMOD^0;
#define CLR_T0M0()            TMOD&=~DEF_SET_BIT0

/*  TL0, 0x8AH, SFR0  */

/*  TL1, 0x8BH, SFR0  */

/*  TH0, 0x8CH, SFR0  */

/*  TH1, 0x8DH, SFR0  */

/*  TCON1, 0x8EH, SFR0  */
#define SET_T1FS()       TCON1|=DEF_SET_BIT7     // TCON1^7;
#define CLR_T1FS()       TCON1&=~DEF_SET_BIT7
#define SET_T1OE()       TCON1|=DEF_SET_BIT6     // TCON1^6;
#define CLR_T1OE()       TCON1&=~DEF_SET_BIT6
#define SET_T1CKS1()     TCON1|=DEF_SET_BIT5     // TCON1^5;
#define CLR_T1CKS1()     TCON1&=~DEF_SET_BIT5
#define SET_T1CKS0()     TCON1|=DEF_SET_BIT4     // TCON1^4;
#define CLR_T1CKS0()     TCON1&=~DEF_SET_BIT4
#define SET_T0FS()       TCON1|=DEF_SET_BIT3     // TCON1^3;
#define CLR_T0FS()       TCON1&=~DEF_SET_BIT3
#define SET_T0OE()       TCON1|=DEF_SET_BIT2     // TCON1^2;
#define CLR_T0OE()       TCON1&=~DEF_SET_BIT2
#define SET_T0CKS1()     TCON1|=DEF_SET_BIT1     // TCON1^1;
#define CLR_T0CKS1()     TCON1&=~DEF_SET_BIT1
#define SET_T0CKS0()     TCON1|=DEF_SET_BIT0     // TCON1^0;
#define CLR_T0CKS0()     TCON1&=~DEF_SET_BIT0

/*  --, 0x8FH, SFR0  */

/*  P1, 0x90H, SFR0  */

/*  P1MOD0, 0x91H, SFR0  */

/*  P1MOD1, 0x92H, SFR0  */

/*  P1PU, 0x93H, SFR0  */

/*  P1PD, 0x94H, SFR0  */

/*  T3CR, 0x95H, SFR0  */
#define SET_TR3()        T3CR|=DEF_SET_BIT7      // T3CR^7;
#define CLR_TR3()        T3CR&=~DEF_SET_BIT7
#define SET_CT3()        T3CR|=DEF_SET_BIT6      // T3CR^6;
#define CLR_CT3()        T3CR&=~DEF_SET_BIT6
#define SET_T3F()        T3CR|=DEF_SET_BIT5      // T3CR^5;
#define CLR_T3F()        T3CR&=~DEF_SET_BIT5 
#define SET_RDCNT()      T3CR|=DEF_SET_BIT4      // T3CR^4;
#define CLR_RDCNT()      T3CR&=~DEF_SET_BIT4
#define SET_T3EN()       T3CR|=DEF_SET_BIT3      // T3CR^4;
#define CLR_T3EN()       T3CR&=~DEF_SET_BIT3
#define SET_T3CKS2()     T3CR|=DEF_SET_BIT2      // T3CR^2;
#define CLR_T3CKS2()     T3CR&=~DEF_SET_BIT2
#define SET_T3CKS1()     T3CR|=DEF_SET_BIT1      // T3CR^1;
#define CLR_T3CKS1()     T3CR&=~DEF_SET_BIT1 
#define SET_T3CKS0()     T3CR|=DEF_SET_BIT0      // T3CR^0;
#define CLR_T3CKS0()     T3CR&=~DEF_SET_BIT0

/*  TL3, 0x96H, SFR0  */

/*  TH3, 0x97H, SFR0  */

/*  SCON0, 0x98H, SFR0  */
#define SET_SM0_FE()       SCON0 |= DEF_SET_BIT7     // SCON0^7;
#define CLR_SM0_FE()       SCON0 &=~DEF_SET_BIT7
#define SET_SM1_RXOV()     SCON0 |= DEF_SET_BIT6     // SCON0^6;
#define CLR_SM1_RXOV()     SCON0 &=~DEF_SET_BIT6
#define SET_SM2_TXCOL()    SCON0 |= DEF_SET_BIT5     // SCON0^5;
#define CLR_SM2_TXCOL()    SCON0 &=~DEF_SET_BIT5
#define SET_REN()          SCON0 |= DEF_SET_BIT4     // SCON0^4;
#define CLR_REN()          SCON0 &=~DEF_SET_BIT4
#define SET_TB8()          SCON0 |= DEF_SET_BIT3     // SCON0^3;
#define CLR_TB8()          SCON0 &=~DEF_SET_BIT3
#define SET_RB8()          SCON0 |= DEF_SET_BIT2     // SCON0^2;
#define CLR_RB8()          SCON0 &=~DEF_SET_BIT2
#define SET_TI()           SCON0 |= DEF_SET_BIT1     // SCON0^1;
#define CLR_TI()           SCON0 &=~DEF_SET_BIT1
#define SET_RI()           SCON0 |= DEF_SET_BIT0     // SCON0^0;
#define CLR_RI()           SCON0 &=~DEF_SET_BIT0

/*  SBUF0, 0x99H, SFR0  */

/*  SADDR, 0x9AH, SFR0  */

/*  SADEN, 0x9BH, SFR0  */
#define SET_SADEN7()   SADEN |= DEF_SET_BIT7     // SADEN^7;
#define CLR_SADEN7()   SADEN &=~DEF_SET_BIT7
#define SET_SADEN6()   SADEN |= DEF_SET_BIT6     // SADEN^6;
#define CLR_SADEN6()   SADEN &=~DEF_SET_BIT6
#define SET_SADEN5()   SADEN |= DEF_SET_BIT5     // SADEN^5;
#define CLR_SADEN5()   SADEN &=~DEF_SET_BIT5
#define SET_SADEN4()   SADEN |= DEF_SET_BIT4     // SADEN^4;
#define CLR_SADEN4()   SADEN &=~DEF_SET_BIT4
#define SET_SADEN3()   SADEN |= DEF_SET_BIT3     // SADEN^3;
#define CLR_SADEN3()   SADEN &=~DEF_SET_BIT3
#define SET_SADEN2()   SADEN |= DEF_SET_BIT2     // SADEN^2;
#define CLR_SADEN2()   SADEN &=~DEF_SET_BIT2
#define SET_SADEN1()   SADEN |= DEF_SET_BIT1     // SADEN^1;
#define CLR_SADEN1()   SADEN &=~DEF_SET_BIT1
#define SET_SADEN0()   SADEN |= DEF_SET_BIT0     // SADEN^0;
#define CLR_SADEN0()   SADEN &=~DEF_SET_BIT0

/*  SCON2, 0x9CH, SFR0  */
// SCON2^7;
// SCON2^6;
// SCON2^5;
// SCON2^4;
#define SET_TEN()         SCON2|= DEF_SET_BIT3      // SCON2^3;
#define CLR_TEN()         SCON2&=~DEF_SET_BIT3
// SCON2^2;
// SCON2^1;
// SCON2^0;

/*  BRGCR, 0x9DH, SFR0  */
#define SET_BRGEN()       BRGCR|= DEF_SET_BIT7      // BRGCR^7;
#define CLR_BRGEN()       BRGCR&=~DEF_SET_BIT7

/*  BRGL, 0x9FH, SFR0  */

/*  P2, 0xA0H, SFR0  */

/*  P2MOD0, 0xA1H, SFR0  */

/*  P2MOD1, 0xA2H, SFR0  */

/*  P2PU, 0xA3H, SFR0  */

/*  P2PD, 0xA4H, SFR0  */

/*  EXTEN1, 0xA5H, SFR0  */
// EXTEN1^7;
// EXTEN1^6;
// EXTEN1^5;
#define SET_EXT1EN4()      EXTEN1 |= DEF_SET_BIT4     // EXTEN1^4;
#define CLR_EXT1EN4()      EXTEN1 &=~DEF_SET_BIT4
#define SET_EXT1EN3()      EXTEN1 |= DEF_SET_BIT3     // EXTEN1^3;
#define CLR_EXT1EN3()      EXTEN1 &=~DEF_SET_BIT3
#define SET_EXT1EN2()      EXTEN1 |= DEF_SET_BIT2     // EXTEN1^2;
#define CLR_EXT1EN2()      EXTEN1 &=~DEF_SET_BIT2
#define SET_EXT1EN1()      EXTEN1 |= DEF_SET_BIT1     // EXTEN1^1;
#define CLR_EXT1EN1()      EXTEN1 &=~DEF_SET_BIT1
#define SET_EXT1EN0()      EXTEN1 |= DEF_SET_BIT0     // EXTEN1^0;
#define CLR_EXT1EN0()      EXTEN1 &=~DEF_SET_BIT0

/*  EXTEN, 0xA6H, SFR0  */
// EXTEN^7;
// EXTEN^6;
// EXTEN^5;
#define SET_EXT0EN4()       EXTEN |= DEF_SET_BIT4     // EXTEN^4;
#define CLR_EXT0EN4()       EXTEN &=~DEF_SET_BIT4
#define SET_EXT0EN3()       EXTEN |= DEF_SET_BIT3     // EXTEN^3;
#define CLR_EXT0EN3()       EXTEN &=~DEF_SET_BIT3
#define SET_EXT0EN2()       EXTEN |= DEF_SET_BIT2     // EXTEN^2;
#define CLR_EXT0EN2()       EXTEN &=~DEF_SET_BIT2
#define SET_EXT0EN1()       EXTEN |= DEF_SET_BIT1     // EXTEN^1;
#define CLR_EXT0EN1()       EXTEN &=~DEF_SET_BIT1
#define SET_EXT0EN0()       EXTEN |= DEF_SET_BIT0     // EXTEN^0;
#define CLR_EXT0EN0()       EXTEN &=~DEF_SET_BIT0

/*  IEN0, 0xA8H, SFR0  */
#define SET_EA()          IEN0 |= DEF_SET_BIT7          // IEN0^7;
#define CLR_EA()          IEN0 &=~DEF_SET_BIT7
#define SET_ADCIE()       IEN0 |= DEF_SET_BIT6          // IEN0^6;
#define CLR_ADCIE()       IEN0 &=~DEF_SET_BIT6
#define SET_SPIIE()       IEN0 |= DEF_SET_BIT5          // IEN0^5;
#define CLR_SPIIE()       IEN0 &=~DEF_SET_BIT5
#define SET_UART0IE()     IEN0 |= DEF_SET_BIT4          // IEN0^4;
#define CLR_UART0IE()     IEN0 &=~DEF_SET_BIT4
#define SET_T1IE()        IEN0 |= DEF_SET_BIT3          // IEN0^3;
#define CLR_T1IE()        IEN0 &=~DEF_SET_BIT3
#define SET_EXT1IE()      IEN0 |= DEF_SET_BIT2          // IEN0^2;
#define CLR_EXT1IE()      IEN0 &=~DEF_SET_BIT2
#define SET_T0IE()        IEN0 |= DEF_SET_BIT1          // IEN0^1;
#define CLR_T0IE()        IEN0 &=~DEF_SET_BIT1
#define SET_EXT0IE()      IEN0 |= DEF_SET_BIT0          // IEN0^0;
#define CLR_EXT0IE()      IEN0 &=~DEF_SET_BIT0

/*  IEN1, 0xAAH, SFR0  */
#define SET_CSSCRCIE()     IEN1 |= DEF_SET_BIT7        // IEN1^7;
#define CLR_CSSCRCIE()     IEN1 &=~DEF_SET_BIT7
#define SET_IICIE()        IEN1 |= DEF_SET_BIT6        // IEN1^6;
#define CLR_IICIE()        IEN1 &=~DEF_SET_BIT6
#define SET_PWM1FBIE()     IEN1 |= DEF_SET_BIT5        // IEN1^5;
#define CLR_PWM1FBIE()     IEN1 &=~DEF_SET_BIT5
#define SET_PWM0IE()       IEN1 |= DEF_SET_BIT4        // IEN1^4;
#define CLR_PWM0IE()       IEN1 &=~DEF_SET_BIT4
// IEN1^3;
#define SET_PWM1IE()       IEN1 |= DEF_SET_BIT2        // IEN1^2;
#define CLR_PWM1IE()       IEN1 &=~DEF_SET_BIT2
#define SET_T3IE()         IEN1 |= DEF_SET_BIT1        // IEN1^1;
#define CLR_T3IE()         IEN1 &=~DEF_SET_BIT1
#define SET_T2IE()         IEN1 |= DEF_SET_BIT0        // IEN1^0;
#define CLR_T2IE()         IEN1 &=~DEF_SET_BIT0

/*  IEN2, 0xABH, SFR0  */
// IEN2^7;
// IEN2^6;
// IEN2^5;
// IEN2^4;
// IEN2^3;
// IEN2^2;
#define SET_LVDIE()     IEN2 |= DEF_SET_BIT1        // IEN2^1;
#define CLR_LVDIE()     IEN2 &=~DEF_SET_BIT1

/*  SPCON, 0xADH, SFR0  */
#define SET_DIR()         SPCON |= DEF_SET_BIT7       // SPCON^7;
#define CLR_DIR()         SPCON &=~DEF_SET_BIT7
#define SET_MSTR()        SPCON |= DEF_SET_BIT6       // SPCON^6;
#define CLR_MSTR()        SPCON &=~DEF_SET_BIT6
#define SET_CPHA()        SPCON |= DEF_SET_BIT5       // SPCON^5;
#define CLR_CPHA()        SPCON &=~DEF_SET_BIT5
#define SET_CPOL()        SPCON |= DEF_SET_BIT4       // SPCON^4;
#define CLR_CPOL()        SPCON &=~DEF_SET_BIT4
#define SET_SSDIS()       SPCON |= DEF_SET_BIT3       // SPCON^3;
#define CLR_SSDIS()       SPCON &=~DEF_SET_BIT3
#define SET_SPR2()        SPCON |= DEF_SET_BIT2       // SPCON^2;
#define CLR_SPR2()        SPCON &=~DEF_SET_BIT2
#define SET_SPR1()        SPCON |= DEF_SET_BIT1       // SPCON^1;
#define CLR_SPR1()        SPCON &=~DEF_SET_BIT1
#define SET_SPR0()        SPCON |= DEF_SET_BIT0       // SPCON^0;
#define CLR_SPR0()        SPCON &=~DEF_SET_BIT0

/*  SPSTA, 0xAEH, SFR0  */
#define SET_SPEN()     SPSTA |= DEF_SET_BIT7     // SPSTA^7;
#define CLR_SPEN()     SPSTA &=~DEF_SET_BIT7
#define SET_SPIF()     SPSTA |= DEF_SET_BIT6     // SPSTA^6;
#define CLR_SPIF()     SPSTA &=~DEF_SET_BIT6
#define SET_MODF()     SPSTA |= DEF_SET_BIT5     // SPSTA^5;
#define CLR_MODF()     SPSTA &=~DEF_SET_BIT5
#define SET_WCOL()     SPSTA |= DEF_SET_BIT4     // SPSTA^4;
#define CLR_WCOL()     SPSTA &=~DEF_SET_BIT4
#define SET_SPIOV()    SPSTA |= DEF_SET_BIT3     // SPSTA^3;
#define CLR_SPIOV()    SPSTA &=~DEF_SET_BIT3
// SPSTA^2;
// SPSTA^1;
// SPSTA^0;

/*  SPDAT, 0xAFH, SFR0  */

/*  EXTIS2, 0xB5H, SFR0  */
#define SET_EXT0A()        EXTIS2 |= DEF_SET_BIT7     // EXTIS2^7;
#define CLR_EXT0A()        EXTIS2 &=~DEF_SET_BIT7
#define SET_EXT1A()        EXTIS2 |= DEF_SET_BIT6     // EXTIS2^6;
#define CLR_EXT1A()        EXTIS2 &=~DEF_SET_BIT6
// EXTIS2^5;
// EXTIS2^4;
#define SET_EXT1IS1()      EXTIS2 |= DEF_SET_BIT3     // EXTIS2^3;
#define CLR_EXT1IS1()      EXTIS2 &=~DEF_SET_BIT3
#define SET_EXT1IS0()      EXTIS2 |= DEF_SET_BIT2     // EXTIS2^2;
#define CLR_EXT1IS0()      EXTIS2 &=~DEF_SET_BIT2
#define SET_EXT0IS1()      EXTIS2 |= DEF_SET_BIT1     // EXTIS2^1;
#define CLR_EXT0IS1()      EXTIS2 &=~DEF_SET_BIT1
#define SET_EXT0IS0()      EXTIS2 |= DEF_SET_BIT0     // EXTIS2^0;
#define CLR_EXT0IS0()      EXTIS2 &=~DEF_SET_BIT0

/*  EXTIS1, 0xB6H, SFR0  */
// EXTIS1^7;
// EXTIS1^6;
// EXTIS1^5;
#define SET_EXT1IF4()      EXTIS1 |= DEF_SET_BIT4     // EXTIS1^4;
#define CLR_EXT1IF4()      EXTIS1 &=~DEF_SET_BIT4
#define SET_EXT1IF3()      EXTIS1 |= DEF_SET_BIT3     // EXTIS1^3;
#define CLR_EXT1IF3()      EXTIS1 &=~DEF_SET_BIT3
#define SET_EXT1IF2()      EXTIS1 |= DEF_SET_BIT2     // EXTIS1^2;
#define CLR_EXT1IF2()      EXTIS1 &=~DEF_SET_BIT2
#define SET_EXT1IF1()      EXTIS1 |= DEF_SET_BIT1     // EXTIS1^1;
#define CLR_EXT1IF1()      EXTIS1 &=~DEF_SET_BIT1
#define SET_EXT1IF0()      EXTIS1 |= DEF_SET_BIT0     // EXTIS1^0;
#define CLR_EXT1IF0()      EXTIS1 &=~DEF_SET_BIT0

/*  EXTIS, 0xB7H, SFR0  */
// EXTIS^7;
// EXTIS^6;
// EXTIS^5;
#define SET_EXT0IF4()       EXTIS |= DEF_SET_BIT4     // EXTIS^4;
#define CLR_EXT0IF4()       EXTIS &=~DEF_SET_BIT4
#define SET_EXT0IF3()       EXTIS |= DEF_SET_BIT3     // EXTIS^3;
#define CLR_EXT0IF3()       EXTIS &=~DEF_SET_BIT3
#define SET_EXT0IF2()       EXTIS |= DEF_SET_BIT2     // EXTIS^2;
#define CLR_EXT0IF2()       EXTIS &=~DEF_SET_BIT2
#define SET_EXT0IF1()       EXTIS |= DEF_SET_BIT1     // EXTIS^1;
#define CLR_EXT0IF1()       EXTIS &=~DEF_SET_BIT1
#define SET_EXT0IF0()       EXTIS |= DEF_SET_BIT0     // EXTIS^0;
#define CLR_EXT0IF0()       EXTIS &=~DEF_SET_BIT0

/*  IPL0, 0xB8H, SFR0  */
// IPL0^7;
#define SET_ADCIPL()      IPL0 |= DEF_SET_BIT6         // IPL0^6;
#define CLR_ADCIPL()      IPL0 &=~DEF_SET_BIT6
#define SET_SPIIPL()      IPL0 |= DEF_SET_BIT5         // IPL0^5;
#define CLR_SPIIPL()      IPL0 &=~DEF_SET_BIT5
#define SET_UART0IPL()    IPL0 |= DEF_SET_BIT4         // IPL0^4;
#define CLR_UART0IPL()    IPL0 &=~DEF_SET_BIT4
#define SET_T1IPL()       IPL0 |= DEF_SET_BIT3         // IPL0^3;
#define CLR_T1IPL()       IPL0 &=~DEF_SET_BIT3
#define SET_EX1IPL()      IPL0 |= DEF_SET_BIT2         // IPL0^2;
#define CLR_EX1IPL()      IPL0 &=~DEF_SET_BIT2
#define SET_T0IPL()       IPL0 |= DEF_SET_BIT1         // IPL0^1;
#define CLR_T0IPL()       IPL0 &=~DEF_SET_BIT1
#define SET_EX0IPL()      IPL0 |= DEF_SET_BIT0         // IPL0^0;
#define CLR_EX0IPL()      IPL0 &=~DEF_SET_BIT0

/*  --, 0xB9H, SFR0  */

/*  --, 0xBAH, SFR0  */

/*  IPL1, 0xBBH, SFR0  */
#define SET_CRCIPL()        IPL1 |= DEF_SET_BIT7      // IPL1^7;
#define CLR_CRCIPL()        IPL1 &=~DEF_SET_BIT7
#define SET_IICIPL()        IPL1 |= DEF_SET_BIT6      // IPL1^6;
#define CLR_IICIPL()        IPL1 &=~DEF_SET_BIT6
#define SET_PWM1FBIPL()     IPL1 |= DEF_SET_BIT5      // IPL1^5;
#define CLR_PWM1FBIL()      IPL1 &=~DEF_SET_BIT5
#define SET_PWM0IPL()       IPL1 |= DEF_SET_BIT4      // IPL1^4;
#define CLR_PWM0IPL()       IPL1 &=~DEF_SET_BIT4
// IPL1^3;
#define SET_PWM1IPL()       IPL1 |= DEF_SET_BIT2      // IPL1^2;
#define CLR_PWM1IPL()       IPL1 &=~DEF_SET_BIT2
#define SET_T3IPL()         IPL1 |= DEF_SET_BIT1      // IPL1^1;
#define CLR_T3IPL()         IPL1 &=~DEF_SET_BIT1
#define SET_T2IPL()         IPL1 |= DEF_SET_BIT0      // IPL1^0;
#define CLR_T2IPL()         IPL1 &=~DEF_SET_BIT0

/*  --, 0xBCH, SFR0  */

/*  IPL2, 0xBDH, SFR0  */
#define SET_LVDIPL()        IPL2 |= DEF_SET_BIT1      // IPL2^1;
#define CLR_LVDIPL()        IPL2 &=~DEF_SET_BIT1

/*  --, 0xBEH, SFR0  */

/*  --, 0xBFH, SFR0  */

/*  CLKCR0, 0xC0H, SFR0  */
#define SET_HIRCEN()        CLKCR0 |= DEF_SET_BIT7      // CLKCR0^7;
#define CLR_HIRCEN()        CLKCR0 &=~DEF_SET_BIT7
// CLKCR0^6;
#define SET_OSCEN()         CLKCR0 |= DEF_SET_BIT5      // CLKCR0^5;
#define CLR_OSCEN()         CLKCR0 &=~DEF_SET_BIT5
#define SET_LIRCEN_LP()     CLKCR0 |= DEF_SET_BIT4      // CLKCR0^4;
#define CLR_LIRCEN_LP()     CLKCR0 &=~DEF_SET_BIT4
// CLKCR0^3;
// CLKCR0^2;
// CLKCR0^1;
// CLKCR0^0;

/*  P0MOD0, 0xC1H, SFR0  */

/*  --, 0xC2H, SFR0  */

/*  P0PU, 0xC3H, SFR0  */

/*  P0PD, 0xC4H, SFR0  */

/*  OSCSS, 0xC5H, SFR0  */

/*  CLKCR1, 0xC6H, SFR0  */
// CLKCR1^7;
#define SET_CLKSW()        CLKCR1 |= DEF_SET_BIT6      // CLKCR1^6;
#define CLR_CLKSW()        CLKCR1 &=~DEF_SET_BIT6
#define SET_FRTCSW()       CLKCR1 |= DEF_SET_BIT5      // CLKCR1^5;
#define CLR_FRTCSW()       CLKCR1 &=~DEF_SET_BIT5
// CLKCR1^4;
// CLKCR1^3;
// CLKCR1^2;
// CLKCR1^1;
// CLKCR1^0;

/*  --, 0xC7H, SFR0  */

/*  T2CON, 0xC8H, SFR0  */
#define SET_TF2()       T2CON |= DEF_SET_BIT7         // T2CON^7;
#define CLR_TF2()       T2CON &=~DEF_SET_BIT7
#define SET_EXTF2()     T2CON |= DEF_SET_BIT6         // T2CON^6;
#define CLR_EXTF2()     T2CON &=~DEF_SET_BIT6
// T2CON^5;
// T2CON^4;
#define SET_EX2EN()     T2CON |= DEF_SET_BIT3         // T2CON^3;
#define CLR_EX2EN()     T2CON &=~DEF_SET_BIT3
#define SET_TR2()       T2CON |= DEF_SET_BIT2         // T2CON^2;
#define CLR_TR2()       T2CON &=~DEF_SET_BIT2
#define SET_CT2()       T2CON |= DEF_SET_BIT1         // T2CON^1;
#define CLR_CT2()       T2CON &=~DEF_SET_BIT1
#define SET_CPRL2()     T2CON |= DEF_SET_BIT0         // T2CON^0;
#define CLR_CPRL2()     T2CON &=~DEF_SET_BIT0

/*  T2MOD, 0xC9H, SFR0  */
#define SET_LD2EN()       T2MOD |= DEF_SET_BIT7       // T2MOD^7;
#define CLR_LD2EN()       T2MOD &=~DEF_SET_BIT7
#define SET_T2CKS2()      T2MOD |= DEF_SET_BIT6       // T2MOD^6;
#define CLR_T2CKS2()      T2MOD &=~DEF_SET_BIT6
#define SET_T2CKS1()      T2MOD |= DEF_SET_BIT5       // T2MOD^5;
#define CLR_T2CKS1()      T2MOD &=~DEF_SET_BIT5
#define SET_T2CKS0()      T2MOD |= DEF_SET_BIT4       // T2MOD^4;
#define CLR_T2CKS0()      T2MOD &=~DEF_SET_BIT4
#define SET_T2OE()        T2MOD |= DEF_SET_BIT3       // T2MOD^3;
#define CLR_T2OE()        T2MOD &=~DEF_SET_BIT3
#define SET_T2SL1()       T2MOD |= DEF_SET_BIT2       // T2MOD^2;
#define CLR_T2SL1()       T2MOD &=~DEF_SET_BIT2
#define SET_T2SL0()       T2MOD |= DEF_SET_BIT1       // T2MOD^1;
#define CLR_T2SL0()       T2MOD &=~DEF_SET_BIT1
// T2MOD^0;

/*  RCAPL2, 0xCAH, SFR0  */

/*  RCAPH2, 0xCBH, SFR0  */

/*  TL2, 0xCCH, SFR0  */

/*  TH2, 0xCDH, SFR0  */

/*  T2CON1, 0xCEH, SFR0  */
#define SET_CM2ON()       T2CON1 |= DEF_SET_BIT7      // T2CON1^7;
#define CLR_CM2ON()       T2CON1 &=~DEF_SET_BIT7
#define SET_CM2()         T2CON1 |= DEF_SET_BIT6      // T2CON1^6;
#define CLR_CM2()         T2CON1 &=~DEF_SET_BIT6
// T2CON1^5;
// T2CON1^4;
// T2CON1^3;
#define SET_EX2SL()       T2CON1 |= DEF_SET_BIT2      // T2CON1^2;
#define CLR_EX2SL()       T2CON1 &=~DEF_SET_BIT2
#define SET_SIGTRG()      T2CON1 |= DEF_SET_BIT1      // T2CON1^1;
#define CLR_SIGTRG()      T2CON1 &=~DEF_SET_BIT1
#define SET_T2EN()        T2CON1 |= DEF_SET_BIT0      // T2CON1^0;
#define CLR_T2EN()        T2CON1 &=~DEF_SET_BIT0

/*  WDTCR, 0xCFH, SFR0  */
// WDTCR^7;
// WDTCR^6;
// WDTCR^5;
// WDTCR^4;
// WDTCR^3;
#define SET_WDTOT2()     WDTCR |= DEF_SET_BIT2        // WDTCR^2;
#define CLR_WDTOT2()     WDTCR &=~DEF_SET_BIT2
#define SET_WDTOT1()     WDTCR |= DEF_SET_BIT1        // WDTCR^1;
#define CLR_WDTOT1()     WDTCR &=~DEF_SET_BIT1
#define SET_WDTOT0()     WDTCR |= DEF_SET_BIT0        // WDTCR^0;
#define CLR_WDTOT0()     WDTCR &=~DEF_SET_BIT0

/*  PSW, 0xD0H, SFR0  */

/*  PWM1OE, 0xD1H, SFR0  */
#define SET_PWM1EN()     PWM1OE |= DEF_SET_BIT7       // PWM1OE^7;
#define CLR_PWM1EN()     PWM1OE &=~DEF_SET_BIT7
// PWM1OE^6;
#define SET_PWMCNOE()    PWM1OE |= DEF_SET_BIT5       // PWM1OE^5;
#define CLR_PWMCNOE()    PWM1OE &=~DEF_SET_BIT5
#define SET_PWMBNOE()    PWM1OE |= DEF_SET_BIT4       // PWM1OE^4;
#define CLR_PWMBNOE()    PWM1OE &=~DEF_SET_BIT4
#define SET_PWMANOE()    PWM1OE |= DEF_SET_BIT3       // PWM1OE^3;
#define CLR_PWMANOE()    PWM1OE &=~DEF_SET_BIT3
#define SET_PWMCOE()     PWM1OE |= DEF_SET_BIT2       // PWM1OE^2;
#define CLR_PWMCOE()     PWM1OE &=~DEF_SET_BIT2
#define SET_PWMBOE()     PWM1OE |= DEF_SET_BIT1       // PWM1OE^1;
#define CLR_PWMBOE()     PWM1OE &=~DEF_SET_BIT1
#define SET_PWMAOE()     PWM1OE |= DEF_SET_BIT0       // PWM1OE^0;
#define CLR_PWMAOE()     PWM1OE &=~DEF_SET_BIT0

/*  PWM1ADL, 0xD2H, SFR0  */

/*  PWM1ADH, 0xD3H, SFR0  */

/*  PWM1BDL, 0xD4H, SFR0  */

/*  PWM1BDH, 0xD5H, SFR0  */

/*  PWM1CDL, 0xD6H, SFR0  */

/*  PWM1CDH, 0xD7H, SFR0  */

/*  PWM1IF, 0xD8H, SFR0  */
#define SET_PWMPIF()       PWM1IF |= DEF_SET_BIT7     // PWM1IF^7;
#define CLR_PWMPIF()       PWM1IF &=~DEF_SET_BIT7
#define SET_PWMZIF()       PWM1IF |= DEF_SET_BIT6     // PWM1IF^6;
#define CLR_PWMZIF()       PWM1IF &=~DEF_SET_BIT6
#define SET_PWMDDCIF()     PWM1IF |= DEF_SET_BIT5     // PWM1IF^5;
#define CLR_PWMDDCIF()     PWM1IF &=~DEF_SET_BIT5
#define SET_PWMUDCIF()     PWM1IF |= DEF_SET_BIT4     // PWM1IF^4;
#define CLR_PWMUDCIF()     PWM1IF &=~DEF_SET_BIT4
#define SET_PWMDDBIF()     PWM1IF |= DEF_SET_BIT3     // PWM1IF^3;
#define CLR_PWMDDBIF()     PWM1IF &=~DEF_SET_BIT3
#define SET_PWMUDBIF()     PWM1IF |= DEF_SET_BIT2     // PWM1IF^2;
#define CLR_PWMUDBIF()     PWM1IF &=~DEF_SET_BIT2
#define SET_PWMDDAIF()     PWM1IF |= DEF_SET_BIT1     // PWM1IF^1;
#define CLR_PWMDDAIF()     PWM1IF &=~DEF_SET_BIT1
#define SET_PWMUDAIF()     PWM1IF |= DEF_SET_BIT0     // PWM1IF^0;
#define CLR_PWMUDAIF()     PWM1IF &=~DEF_SET_BIT0

/*  PWM1RLEN, 0xD9H, SFR0  */

/*  PWM1CR1, 0xDAH, SFR0  */
// PWM1CR1^7;
// PWM1CR1^6;
#define SET_PWMCNS()      PWM1CR1 |= DEF_SET_BIT5     // PWM1CR1^5;
#define CLR_PWMCNS()      PWM1CR1 &=~DEF_SET_BIT5
#define SET_PWMBNS()      PWM1CR1 |= DEF_SET_BIT4     // PWM1CR1^4;
#define CLR_PWMBNS()      PWM1CR1 &=~DEF_SET_BIT4
#define SET_PWMANS()      PWM1CR1 |= DEF_SET_BIT3     // PWM1CR1^3;
#define CLR_PWMANS()      PWM1CR1 &=~DEF_SET_BIT3
#define SET_PWMCS()       PWM1CR1 |= DEF_SET_BIT2     // PWM1CR1^2;
#define CLR_PWMCS()       PWM1CR1 &=~DEF_SET_BIT2
#define SET_PWMBS()       PWM1CR1 |= DEF_SET_BIT1     // PWM1CR1^1;
#define CLR_PWMBS()       PWM1CR1 &=~DEF_SET_BIT1
#define SET_PWMAS()       PWM1CR1 |= DEF_SET_BIT0     // PWM1CR1^0;
#define CLR_PWMAS()       PWM1CR1 &=~DEF_SET_BIT0

/*  PWM1CR2, 0xDBH, SFR0  */
#define SET_TRGTIM1()     PWM1CR2 |= DEF_SET_BIT7     // PWM1CR2^7;
#define CLR_TRGTIM1()     PWM1CR2 &=~DEF_SET_BIT7
#define SET_TRGTIM0()     PWM1CR2 |= DEF_SET_BIT6     // PWM1CR2^6;
#define CLR_TRGTIM0()     PWM1CR2 &=~DEF_SET_BIT6
#define SET_PTRGAD()      PWM1CR2 |= DEF_SET_BIT5     // PWM1CR2^5;
#define CLR_PTRGAD()      PWM1CR2 &=~DEF_SET_BIT5
#define SET_ZTRGAD()      PWM1CR2 |= DEF_SET_BIT4     // PWM1CR2^4;
#define CLR_ZTRGAD()      PWM1CR2 &=~DEF_SET_BIT4
#define SET_PLDEN()       PWM1CR2 |= DEF_SET_BIT3     // PWM1CR2^3;
#define CLR_PLDEN()       PWM1CR2 &=~DEF_SET_BIT3
#define SET_OSYNC()       PWM1CR2 |= DEF_SET_BIT2     // PWM1CR2^2;
#define CLR_OSYNC()       PWM1CR2 &=~DEF_SET_BIT2
// PWM1CR2^1;
// PWM1CR2^0; 

/*  PWM1FBCR, 0xDCH, SFR0  */
// PWM1FBCR^7;
// PWM1FBCR^6;
#define SET_FB1EN()       PWM1FBCR |= DEF_SET_BIT5    // PWM1FBCR^5;
#define CLR_FB1EN()       PWM1FBCR &=~DEF_SET_BIT5
#define SET_FB1S()        PWM1FBCR |= DEF_SET_BIT4    // PWM1FBCR^4;
#define CLR_FB1S()        PWM1FBCR &=~DEF_SET_BIT4
#define SET_FB1FLT1()     PWM1FBCR |= DEF_SET_BIT3    // PWM1FBCR^3;
#define CLR_FB1FLT1()     PWM1FBCR &=~DEF_SET_BIT3
#define SET_FB1FLT0()     PWM1FBCR |= DEF_SET_BIT2    // PWM1FBCR^2;
#define CLR_FB1FLT0()     PWM1FBCR &=~DEF_SET_BIT2
// PWM1FBCR^1;
#define SET_FBSTA()       PWM1FBCR |= DEF_SET_BIT0    // PWM1FBCR^0;
#define CLR_FBSTA()       PWM1FBCR &=~DEF_SET_BIT0

/*  PWM1MANCR0, 0xDDH, SFR0  */
// PWM1MANCR0^7;
// PWM1MANCR0^6;
#define SET_MANCN()    PWM1MANCR0 |= DEF_SET_BIT5     // PWM1MANCR0^5;
#define CLR_MANCN()    PWM1MANCR0 &=~DEF_SET_BIT5
#define SET_MANBN()    PWM1MANCR0 |= DEF_SET_BIT4     // PWM1MANCR0^4;
#define CLR_MANBN()    PWM1MANCR0 &=~DEF_SET_BIT4
#define SET_MANAN()    PWM1MANCR0 |= DEF_SET_BIT3     // PWM1MANCR0^3;
#define CLR_MANAN()    PWM1MANCR0 &=~DEF_SET_BIT3
#define SET_MANC()     PWM1MANCR0 |= DEF_SET_BIT2     // PWM1MANCR0^2;
#define CLR_MANC()     PWM1MANCR0 &=~DEF_SET_BIT2
#define SET_MANB()     PWM1MANCR0 |= DEF_SET_BIT1     // PWM1MANCR0^1;
#define CLR_MANB()     PWM1MANCR0 &=~DEF_SET_BIT1
#define SET_MANA()     PWM1MANCR0 |= DEF_SET_BIT0     // PWM1MANCR0^0;
#define CLR_MANA()     PWM1MANCR0 &=~DEF_SET_BIT0

/*  PWM1MANCR1, 0xDEH, SFR0  */
// PWM1MANCR1^7;
// PWM1MANCR1^6;
#define SET_PWMOCN()    PWM1MANCR1 |= DEF_SET_BIT5    // PWM1MANCR1^5;
#define CLR_PWMOCN()    PWM1MANCR1 &=~DEF_SET_BIT5
#define SET_PWMOBN()    PWM1MANCR1 |= DEF_SET_BIT4    // PWM1MANCR1^4;
#define CLR_PWMOBN()    PWM1MANCR1 &=~DEF_SET_BIT4
#define SET_PWMOAN()    PWM1MANCR1 |= DEF_SET_BIT3    // PWM1MANCR1^3;
#define CLR_PWMOAN()    PWM1MANCR1 &=~DEF_SET_BIT3
#define SET_PWMOC()     PWM1MANCR1 |= DEF_SET_BIT2    // PWM1MANCR1^2;
#define CLR_PWMOC()     PWM1MANCR1 &=~DEF_SET_BIT2
#define SET_PWMOB()     PWM1MANCR1 |= DEF_SET_BIT1    // PWM1MANCR1^1;
#define CLR_PWMOB()     PWM1MANCR1 &=~DEF_SET_BIT1
#define SET_PWMOA()     PWM1MANCR1 |= DEF_SET_BIT0    // PWM1MANCR1^0;
#define CLR_PWMOA()     PWM1MANCR1 &=~DEF_SET_BIT0

/*  IAPCR1, 0xDFH, SFR0  */
// IAPCR1^7;
#define SET_MFREF()       IAPCR1 |= DEF_SET_BIT6      // IAPCR1^6;
#define CLR_MFREF()       IAPCR1 &=~DEF_SET_BIT6
#define SET_IAPERR()      IAPCR1 |= DEF_SET_BIT5      // IAPCR1^5;
#define CLR_IAPERR()      IAPCR1 &=~DEF_SET_BIT5
// IAPCR1^4;
#define SET_PCFEN()       IAPCR1 |= DEF_SET_BIT3      // IAPCR1^3;
#define CLR_PCFEN()       IAPCR1 &=~DEF_SET_BIT3
#define SET_UCFEN()       IAPCR1 |= DEF_SET_BIT2      // IAPCR1^2;
#define CLR_UCFEN()       IAPCR1 &=~DEF_SET_BIT2
// IAPCR1^1;
#define SET_MFREN()       IAPCR1 |= DEF_SET_BIT0      // IAPCR1^0;
#define CLR_MFREN()       IAPCR1 &=~DEF_SET_BIT0

/*  IICCR0, 0xE1H, SFR0  */
#define SET_IICEN()       IICCR0 |= DEF_SET_BIT7      // IICCR0^7;
#define CLR_IICEN()       IICCR0 &=~DEF_SET_BIT7
#define SET_IICMOD()      IICCR0 |= DEF_SET_BIT6      // IICCR0^6;
#define CLR_IICMOD()      IICCR0 &=~DEF_SET_BIT6
#define SET_IICSPD()      IICCR0 |= DEF_SET_BIT5      // IICCR0^5;
#define CLR_IICSPD()      IICCR0 &=~DEF_SET_BIT5
#define SET_IICSYN()      IICCR0 |= DEF_SET_BIT4      // IICCR0^4;
#define CLR_IICSYN()      IICCR0 &=~DEF_SET_BIT4
#define SET_IICGCE()      IICCR0 |= DEF_SET_BIT3      // IICCR0^3;
#define CLR_IICGCE()      IICCR0 &=~DEF_SET_BIT3
// IICCR0^2;
// IICCR0^1;
#define SET_IICRUS()      IICCR0 |= DEF_SET_BIT0      // IICCR0^0;
#define CLR_IICRUS()      IICCR0 &=~DEF_SET_BIT0

/*  IICCR1, 0xE2H, SFR0  */
// IICCR1^7;
// IICCR1^6;
// IICCR1^5;
#define SET_MNASTPE()      IICCR1 |= DEF_SET_BIT4      // IICCR1^4;
#define CLR_MNASTPE()      IICCR1 &=~DEF_SET_BIT4
#define SET_MTSAA()        IICCR1 |= DEF_SET_BIT3      // IICCR1^3;
#define CLR_MTSAA()        IICCR1 &=~DEF_SET_BIT3
#define SET_MTSTP()        IICCR1 |= DEF_SET_BIT2      // IICCR1^2;
#define CLR_MTSTP()        IICCR1 &=~DEF_SET_BIT2
#define SET_MTDTA()        IICCR1 |= DEF_SET_BIT1      // IICCR1^1;
#define CLR_MTDTA()        IICCR1 &=~DEF_SET_BIT1
#define SET_MRDTA()        IICCR1 |= DEF_SET_BIT0      // IICCR1^0;
#define CLR_MRDTA()        IICCR1 &=~DEF_SET_BIT0

/*  IICSR, 0xE3H, SFR0  */
#define SET_TACKS()       IICSR |= DEF_SET_BIT7      // IICSR^7;
#define CLR_TACKS()       IICSR &=~DEF_SET_BIT7

/*  IICAR, 0xE4H, SFR0  */

/*  IICDR, 0xE5H, SFR0  */

/*  IICAAR, 0xE6H, SFR0  */

/*  IICAMR, 0xE7H, SFR0  */

/*  RSTFLAG, 0xE8H, SFR0  */
#define SET_PORF()        RSTFLAG |= DEF_SET_BIT7     // RSTFLAG^7;
#define CLR_PORF()        RSTFLAG &=~DEF_SET_BIT7
#define SET_LVRF()        RSTFLAG |= DEF_SET_BIT6     // RSTFLAG^6;
#define CLR_LVRF()        RSTFLAG &=~DEF_SET_BIT6
#define SET_RSTF()        RSTFLAG |= DEF_SET_BIT5     // RSTFLAG^5;
#define CLR_RSTF()        RSTFLAG &=~DEF_SET_BIT5
#define SET_WDTRF()       RSTFLAG |= DEF_SET_BIT4     // RSTFLAG^4;
#define CLR_WDTRF()       RSTFLAG &=~DEF_SET_BIT4
#define SET_SWRF()        RSTFLAG |= DEF_SET_BIT3     // RSTFLAG^3;
#define CLR_SWRF()        RSTFLAG &=~DEF_SET_BIT3
// RSTFLAG^2;
// RSTFLAG^1;
#define SET_SWRST()       RSTFLAG |= DEF_SET_BIT0     // RSTFLAG^0;
#define CLR_SWRST()       RSTFLAG &=~DEF_SET_BIT0

/*  IAPCR, 0xE9H, SFR0  */
#define SET_IAPSTR()      IAPCR |= DEF_SET_BIT7      // IAPCR^7;
#define CLR_IAPSTR()      IAPCR &=~DEF_SET_BIT7
// IAPCR^6;
// IAPCR^5;
#define SET_BLRS()        IAPCR |= DEF_SET_BIT4      // IAPCR^4;
#define CLR_BLRS()        IAPCR &=~DEF_SET_BIT4
#define SET_IAPTRIG2()    IAPCR |= DEF_SET_BIT3      // IAPCR^3;
#define CLR_IAPTRIG2()    IAPCR &=~DEF_SET_BIT3
#define SET_IAPTRIG1()    IAPCR |= DEF_SET_BIT2      // IAPCR^2;
#define CLR_IAPTRIG1()    IAPCR &=~DEF_SET_BIT2
#define SET_IAPTRIG0()    IAPCR |= DEF_SET_BIT1      // IAPCR^1;
#define CLR_IAPTRIG0()    IAPCR &=~DEF_SET_BIT1
#define SET_INFOS()       IAPCR |= DEF_SET_BIT0      // IAPCR^0;
#define CLR_INFOS()       IAPCR &=~DEF_SET_BIT0

/*  IAPADL, 0xEAH, SFR0  */

/*  IAPADH, 0xEBH, SFR0  */

/*  IAPDBL, 0xECH, SFR0  */

/*  IAPDBH, 0xEDH, SFR0  */

/*  IAPMD, 0xEEH, SFR0  */
#define SET_IAPEN()        IAPMD |= DEF_SET_BIT7      // IAPMD^7;
#define CLR_IAPEN()        IAPMD &=~DEF_SET_BIT7
// IAPMD^6;
#define SET_CLRPL()        IAPMD |= DEF_SET_BIT5      // IAPMD^5;
#define CLR_CLRPL()        IAPMD &=~DEF_SET_BIT5
// IAPMD^4;
// IAPMD^3;
#define SET_PAGEERS()      IAPMD |= DEF_SET_BIT2      // IAPMD^2;
#define CLR_PAGEERS()      IAPMD &=~DEF_SET_BIT2
// IAPMD^1;
#define SET_PROWR()        IAPMD |= DEF_SET_BIT0      // IAPMD^0;
#define CLR_PROWR()        IAPMD &=~DEF_SET_BIT0

/*  IAPKEY, 0xEFH, SFR0  */

/*  ADCCR0, 0xF1H, SFR0  */
#define SET_ADCHS3()      ADCCR0 |= DEF_SET_BIT7      // ADCCR0^7;
#define CLR_ADCHS3()      ADCCR0 &=~DEF_SET_BIT7
#define SET_ADCHS2()      ADCCR0 |= DEF_SET_BIT6      // ADCCR0^6;
#define CLR_ADCHS2()      ADCCR0 &=~DEF_SET_BIT6
#define SET_ADCHS1()      ADCCR0 |= DEF_SET_BIT5      // ADCCR0^5;
#define CLR_ADCHS1()      ADCCR0 &=~DEF_SET_BIT5
#define SET_ADCHS0()      ADCCR0 |= DEF_SET_BIT4      // ADCCR0^4;
#define CLR_ADCHS0()      ADCCR0 &=~DEF_SET_BIT4
#define SET_VRS1()        ADCCR0 |= DEF_SET_BIT3      // ADCCR0^3;
#define CLR_VRS1()        ADCCR0 &=~DEF_SET_BIT3
#define SET_VRS0()        ADCCR0 |= DEF_SET_BIT2      // ADCCR0^2;
#define CLR_VRS0()        ADCCR0 &=~DEF_SET_BIT2
// #define SET_GODONE()       ADCCR0 |= DEF_SET_BIT1      // ADCCR0^1;    //Ӳ1,0
#define CLR_GODONE()      ADCCR0 &=~DEF_SET_BIT1
#define SET_ADEN()        ADCCR0 |= DEF_SET_BIT0      // ADCCR0^0;
#define CLR_ADEN()        ADCCR0 &=~DEF_SET_BIT0

/*  ADCCR1, 0xF2H, SFR0  */
#define SET_ADRSEL()       ADCCR1 |= DEF_SET_BIT7      // ADCCR1^7;
#define CLR_ADRSEL()       ADCCR1 &=~DEF_SET_BIT7
#define SET_ADCKS2()       ADCCR1 |= DEF_SET_BIT6      // ADCCR1^6;
#define CLR_ADCKS2()       ADCCR1 &=~DEF_SET_BIT6
#define SET_ADCKS1()       ADCCR1 |= DEF_SET_BIT5      // ADCCR1^5;
#define CLR_ADCKS1()       ADCCR1 &=~DEF_SET_BIT5
#define SET_ADCKS0()       ADCCR1 |= DEF_SET_BIT4      // ADCCR1^4;
#define CLR_ADCKS0()       ADCCR1 &=~DEF_SET_BIT4
// ADCCR1^3;
#define SET_ADSPS2()       ADCCR1 |= DEF_SET_BIT2      // ADCCR1^2;
#define CLR_ADSPS2()       ADCCR1 &=~DEF_SET_BIT2
#define SET_ADSPS1()       ADCCR1 |= DEF_SET_BIT1      // ADCCR1^1;
#define CLR_ADSPS1()       ADCCR1 &=~DEF_SET_BIT1
#define SET_ADSPS0()       ADCCR1 |= DEF_SET_BIT0      // ADCCR1^0;
#define CLR_ADSPS0()       ADCCR1 &=~DEF_SET_BIT0

/*  ADCCR2, 0xF3H, SFR0  */
#define SET_ADECOIE()       ADCCR2 |= DEF_SET_BIT7      // ADCCR2^7;
#define CLR_ADECOIE()       ADCCR2 &=~DEF_SET_BIT7
#define SET_ADCMPIE()       ADCCR2 |= DEF_SET_BIT6      // ADCCR2^6;
#define CLR_ADCMPIE()       ADCCR2 &=~DEF_SET_BIT6
#define SET_ADCMPEN()       ADCCR2 |= DEF_SET_BIT5      // ADCCR2^5;
#define CLR_ADCMPEN()       ADCCR2 &=~DEF_SET_BIT5
#define SET_ADCMPDIR()      ADCCR2 |= DEF_SET_BIT4      // ADCCR2^4;
#define CLR_ADCMPDIR()      ADCCR2 &=~DEF_SET_BIT4
#define SET_ADCONT()        ADCCR2 |= DEF_SET_BIT3      // ADCCR2^3;
#define CLR_ADCONT()        ADCCR2 &=~DEF_SET_BIT3
#define SET_ADTRG2()        ADCCR2 |= DEF_SET_BIT2      // ADCCR2^2;
#define CLR_ADTRG2()        ADCCR2 &=~DEF_SET_BIT2
#define SET_ADTRG1()        ADCCR2 |= DEF_SET_BIT1      // ADCCR2^1;
#define CLR_ADTRG1()        ADCCR2 &=~DEF_SET_BIT1
#define SET_ADTRG0()        ADCCR2 |= DEF_SET_BIT0      // ADCCR2^0;
#define CLR_ADTRG0()        ADCCR2 &=~DEF_SET_BIT0

/*  ADCCR3, 0xF4H, SFR0  */
#define SET_ADGAIN1()       ADCCR3 |= DEF_SET_BIT7      // ADCCR3^7;
#define CLR_ADGAIN1()       ADCCR3 &=~DEF_SET_BIT7
#define SET_ADGAIN0()       ADCCR3 |= DEF_SET_BIT6      // ADCCR3^6;
#define CLR_ADGAIN0()       ADCCR3 &=~DEF_SET_BIT6
// ADCCR3^5;
// ADCCR3^4;
// ADCCR3^3;
// ADCCR3^2;
// ADCCR3^1;
#define SET_ADVREFEN()       ADCCR3 |= DEF_SET_BIT0      // ADCCR3^0;
#define CLR_ADVREFEN()       ADCCR3 &=~DEF_SET_BIT0

/*  OSADJCR, 0xF5H, SFR0  */
#define SET_OSADJEN()       OSADJCR |= DEF_SET_BIT7      // OSADJCR^7;
#define CLR_OSADJEN()       OSADJCR &=~DEF_SET_BIT7

/*  LVDCR, 0xF6H, SFR0  */
#define SET_LVDEN()         LVDCR |= DEF_SET_BIT7        // LVDCR^7;
#define CLR_LVDEN()         LVDCR &=~DEF_SET_BIT7
// LVDCR^6;
#define SET_LVDIF()         LVDCR |= DEF_SET_BIT5        // LVDCR^7;
#define CLR_LVDIF()         LVDCR &=~DEF_SET_BIT5
// LVDCR^4;
// LVDCR^3;
// LVDCR^2;
// LVDCR^1;
// LVDCR^0;

/*  LVDCR1, 0xF7H, SFR0  */

/*  PWRCR, 0xF8H, SFR0  */
// PWRCR^7;
// PWRCR^6;
#define SET_PWM1_CLKEN()   PWRCR |= DEF_SET_BIT5      // PWRCR^5;
#define CLR_PWM1_CLKEN()   PWRCR &=~DEF_SET_BIT5
#define SET_PWM0_CLKEN()   PWRCR |= DEF_SET_BIT4      // PWRCR^4;
#define CLR_PWM0_CLKEN()   PWRCR &=~DEF_SET_BIT4
#define SET_SPI_CLKEN()    PWRCR |= DEF_SET_BIT3      // PWRCR^3;
#define CLR_SPI_CLKEN()    PWRCR &=~DEF_SET_BIT3
#define SET_ADC_CLKEN()    PWRCR |= DEF_SET_BIT2      // PWRCR^2;
#define CLR_ADC_CLKEN()    PWRCR &=~DEF_SET_BIT2
// PWRCR^1;
#define SET_OCD_CLKEN()    PWRCR |= DEF_SET_BIT0      // PWRCR^0;
#define CLR_OCD_CLKEN()    PWRCR &=~DEF_SET_BIT0

/*  PWRCR1, 0xF9H, SFR0  */
// PWRCR1^7;
#define SET_IIC_CLKEN()    PWRCR1 |= DEF_SET_BIT6     // PWRCR1^6;
#define CLR_IIC_CLKEN()    PWRCR1 &=~DEF_SET_BIT6
#define SET_CRC_CLKEN()    PWRCR1 |= DEF_SET_BIT5     // PWRCR1^5;
#define CLR_CRC_CLKEN()    PWRCR1 &=~DEF_SET_BIT5
// PWRCR1^4;
// PWRCR1^3;
#define SET_T3_CLKEN()     PWRCR1 |= DEF_SET_BIT2     // PWRCR1^2;
#define CLR_T3_CLKEN()     PWRCR1 &=~DEF_SET_BIT2
#define SET_T2_CLKEN()     PWRCR1 |= DEF_SET_BIT1     // PWRCR1^1;
#define CLR_T2_CLKEN()     PWRCR1 &=~DEF_SET_BIT1
#define SET_T01_CLKEN()    PWRCR1 |= DEF_SET_BIT0     // PWRCR1^0;
#define CLR_T01_CLKEN()    PWRCR1 &=~DEF_SET_BIT0

/*  ADCMPL, 0xFAH, SFR0  */

/*  ADCMPH, 0xFBH, SFR0  */

/*  -- 0xFCH, SFR0  */

/*  ADRIOS1, 0xFDH, SFR0  */
// ADRIOS1^7;
// ADRIOS1^6;
#define SET_EX_VREF_EN()    ADRIOS1 |= DEF_SET_BIT5     // ADRIOS1^1;
#define CLR_EX_VREF_EN()    ADRIOS1 &=~DEF_SET_BIT5
// ADRIOS1^4;
// ADRIOS1^3;
// ADRIOS1^2;
#define SET_AN9EN()         ADRIOS1 |= DEF_SET_BIT1     // ADRIOS1^1;
#define CLR_AN9EN()         ADRIOS1 &=~DEF_SET_BIT1
#define SET_AN8EN()         ADRIOS1 |= DEF_SET_BIT0     // ADRIOS1^0;
#define CLR_AN8EN()         ADRIOS1 &=~DEF_SET_BIT0

/*  ADRL, 0xFEH, SFR0  */
/*  ADRH, 0xFFH, SFR0  */



/*  XSFR  */
/*  PWM1CR0, 0xFF48H, XSFR  */
#define SET_CLKSEL()      PWM1CR0 |= DEF_SET_BIT7     // PWM1CR0^7;
#define CLR_CLKSEL()      PWM1CR0 &=~DEF_SET_BIT7
// PWM1CR0^6;
#define SET_CTMOD1()      PWM1CR0 |= DEF_SET_BIT5     // PWM1CR0^5;
#define CLR_CTMOD1()      PWM1CR0 &=~DEF_SET_BIT5
#define SET_CTMOD0()      PWM1CR0 |= DEF_SET_BIT4     // PWM1CR0^4;
#define CLR_CTMOD0()      PWM1CR0 &=~DEF_SET_BIT4
#define SET_PREDIV1()     PWM1CR0 |= DEF_SET_BIT3     // PWM1CR0^3;
#define CLR_PREDIV1()     PWM1CR0 &=~DEF_SET_BIT3
#define SET_PREDIV0()     PWM1CR0 |= DEF_SET_BIT2     // PWM1CR0^2;
#define CLR_PREDIV0()     PWM1CR0 &=~DEF_SET_BIT2
#define SET_POSTDIV1()    PWM1CR0 |= DEF_SET_BIT1     // PWM1CR0^1;
#define CLR_POSTDIV1()    PWM1CR0 &=~DEF_SET_BIT1
#define SET_POSTDIV0()    PWM1CR0 |= DEF_SET_BIT0     // PWM1CR0^0;
#define CLR_POSTDIV0()    PWM1CR0 &=~DEF_SET_BIT0

/*  PWM1IE, 0xFF49H, XSFR  */
#define SET_PWMPIE()       PWM1IE |= DEF_SET_BIT7     // PWM1IE^7;
#define CLR_PWMPIE()       PWM1IE &=~DEF_SET_BIT7
#define SET_PWMZIE()       PWM1IE |= DEF_SET_BIT6     // PWM1IE^6;
#define CLR_PWMZIE()       PWM1IE &=~DEF_SET_BIT6
#define SET_PWMDDCIE()     PWM1IE |= DEF_SET_BIT5     // PWM1IE^5;
#define CLR_PWMDDCIE()     PWM1IE &=~DEF_SET_BIT5
#define SET_PWMUDCIE()     PWM1IE |= DEF_SET_BIT4     // PWM1IE^4;
#define CLR_PWMUDCIE()     PWM1IE &=~DEF_SET_BIT4
#define SET_PWMDDBIE()     PWM1IE |= DEF_SET_BIT3     // PWM1IE^3;
#define CLR_PWMDDBIE()     PWM1IE &=~DEF_SET_BIT3
#define SET_PWMUDBIE()     PWM1IE |= DEF_SET_BIT2     // PWM1IE^2;
#define CLR_PWMUDBIE()     PWM1IE &=~DEF_SET_BIT2
#define SET_PWMDDAIE()     PWM1IE |= DEF_SET_BIT1     // PWM1IE^1;
#define CLR_PWMDDAIE()     PWM1IE &=~DEF_SET_BIT1
#define SET_PWMUDAIE()     PWM1IE |= DEF_SET_BIT0     // PWM1IE^0;
#define CLR_PWMUDAIE()     PWM1IE &=~DEF_SET_BIT0

/*  PWM1PH, 0xFF4AH, XSFR  */

/*  PWM1PL, 0xFF4BH, XSFR  */

/*  PWM1DT0L, 0xFF4DH, XSFR  */

/*  CRCCR, 0xFF60H, XSFR  */
#define SET_CRCEN()       CRCCR |= DEF_SET_BIT7       // CRCCR^7;
#define CLR_CRCEN()       CRCCR &=~DEF_SET_BIT7
// CRCCR^6;
//#define SET_CRCIF()       CRCCR |= DEF_SET_BIT5     // CRCCR^5;    //Ӳ1,0
#define CLR_CRCIF()       CRCCR &=~DEF_SET_BIT5
#define SET_CRCST()       CRCCR |= DEF_SET_BIT4       // CRCCR^4;
//#define CLR_CRCST()       CRCCR &=~DEF_SET_BIT4                    //Ӳ0,1
#define SET_CRCMD()       CRCCR |= DEF_SET_BIT3       // CRCCR^3;
#define CLR_CRCMD()       CRCCR &=~DEF_SET_BIT3
#define SET_CRCLCT()      CRCCR |= DEF_SET_BIT2       // CRCCR^2;
#define CLR_CRCLCT()      CRCCR &=~DEF_SET_BIT2
// CRCCR^1;
#define SET_CRCENC()      CRCCR |= DEF_SET_BIT0       // CRCCR^0;
#define CLR_CRCENC()      CRCCR &=~DEF_SET_BIT0

/*  CRCH, 0xFF62H, XSFR  */

/*  CRCL, 0xFF63H, XSFR  */

/*  CRCSTH, 0xFF64H, XSFR  */

/*  CRCSTL, 0xFF65H, XSFR  */

/*  CRCEDH, 0xFF66H, XSFR  */

/*  CRCEDL, 0xFF67H, XSFR  */

/*  PWM0CR, 0xFF68H, XSFR  */
#define SET_PWM0EN()       PWM0CR |= DEF_SET_BIT7     // PWM0CR^7;
#define CLR_PWM0EN()       PWM0CR &=~DEF_SET_BIT7
#define SET_PWM0PIE()      PWM0CR |= DEF_SET_BIT6     // PWM0CR^6;
#define CLR_PWM0PIE()      PWM0CR &=~DEF_SET_BIT6
//#define SET_PWM0IF()       PWM0CR |= DEF_SET_BIT5     // PWM0CR^5;    //Ӳ1,0
#define CLR_PWM0IF()       PWM0CR &=~DEF_SET_BIT5
#define SET_PWM0AOE()      PWM0CR |= DEF_SET_BIT4     // PWM0CR^4;
#define CLR_PWM0AOE()      PWM0CR &=~DEF_SET_BIT4
#define SET_PWM0AS()       PWM0CR |= DEF_SET_BIT3     // PWM0CR^3;
#define CLR_PWM0AS()       PWM0CR &=~DEF_SET_BIT3
#define SET_PWM0C2()       PWM0CR |= DEF_SET_BIT2     // PWM0CR^2;
#define CLR_PWM0C2()       PWM0CR &=~DEF_SET_BIT2
#define SET_PWM0C1()       PWM0CR |= DEF_SET_BIT1     // PWM0CR^1;
#define CLR_PWM0C1()       PWM0CR &=~DEF_SET_BIT1
#define SET_PWM0C0()       PWM0CR |= DEF_SET_BIT0     // PWM0CR^0;
#define CLR_PWM0C0()       PWM0CR &=~DEF_SET_BIT0

/*  PWM0P, 0xFF69H, XSFR  */

/*  PWM0D, 0xFF6AH, XSFR  */

#endif
