/******************************************************************************
;  *       @ͺ                 : MC51F7084
;  *       @             : 2024.05.09
;  *       @˾/            : ΢-FAE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : 2024 ΢Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                   UART ʣ9600
;  *                   UART TX -- P23D   RX-P22D
******************************************************************************/

#include "UART.h"

unsigned int uart_cont;
unsigned int uart_trim;
		
/************************************************
;  *    @            : UART1_Init
;  *    @˵              : UARTʼ
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void UART0_Init(void)
{
    PCON |= DEF_SET_BIT4;         //ʹUART0
    BRGCR |= DEF_SET_BIT7;
    SCON2 = 0x08;                 //TX0ЧTX0-P23,RX0-P22
    SCON0 &= 0x3E;
    SCON0 |= 0x50;                //ʽ1  
    BRGH = band_CntH;
    BRGL = band_CntL;
    IEN0 |= DEF_SET_BIT4;         //UART0ж
	  
}

/************************************************
;  *    @            : putchar
;  *    @˵              : ڷ
;  *    @          : tx_data
;  *    @ز          :
;  ***********************************************/
char putchar(char tx_data)
{
    SBUF0 = tx_data;              //дݵUARTݼĴ
    while (!(SCON0 & 0x02));      //ȴǰݷ
    SCON0 &= ~DEF_SET_BIT1;
    return tx_data;
}

void UART0_ISR(void) interrupt UART0_IRQn
{
    if(((SCON0 & DEF_SET_BIT0) == DEF_SET_BIT0))
    {
        SCON0 &= ~DEF_SET_BIT0;
        if(UART_RX_END == 0)
        {
            if(UART_RX_STA == 0)
            {
                if(SBUF0 == 0x0d)     //յ0x0d
                {
                    UART_RX_STA = 1;
                    UART_rx_len = 0;
                }
            }
            else
            {
                if(SBUF0 != 0x0a)     //յ0x0a
                {
                    UART_rx_buff[UART_rx_len] = SBUF0;
                    UART_rx_len++;
                }
                else
                {
                    UART_RX_END = 1;
                    UART_RX_STA = 0;
                }
            }
        }
    }
}